

public class Timer extends Thread {

	private short time = 300;

	private boolean expired = false;
	
	private boolean active = false;
	
	public Timer() {
		setDaemon(true);
	}

	public void run() {

		while (true) {

			try {
				synchronized (this) {
					active = false;
					wait();
				}
			} catch (InterruptedException e) {
				//gr?n gefunden
			}

			try {
				active = true;
				expired = false;
				Thread.sleep(time);
				expired = true;
			} catch (InterruptedException e) {
				//andere Farbe innerhalb der Zeitspanne gefunden
			}

		}
	}

	public synchronized void stopTimer() {
		expired = false;
		synchronized (this) {
			if (active) interrupt();		
		}
	}
	
	public synchronized void startTimer() {
		
		synchronized (this) {
			if (!active) notify();
		}
	}
	
	public synchronized boolean isActive() {
		
		return active;
	}
	
	
	public short getTime() {
		return time;
	}

	public synchronized void setTime(short time) {
		this.time = time;
	}

	public synchronized boolean isExpired() {
		return expired;
	}

}
